// HDATest1.h : main header file for the HDATEST1 application
//

#if !defined(AFX_HDATEST1_H__127D0739_E0E3_11D4_810A_00C04F790F3B__INCLUDED_)
#define AFX_HDATEST1_H__127D0739_E0E3_11D4_810A_00C04F790F3B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols


class	CHDATest1View;
class	CEventVW;

/////////////////////////////////////////////////////////////////////////////
//
// This is an override of the Callback function that the DLL will
// use when it needs information from us.
//
class CMyDataCallback : public CWtHDACallback
{
public:
	CMyDataCallback();
    ~CMyDataCallback();

	// Historical Data Item Functions
	int GetTimeStamps (HANDLE hItem, FILETIME *pStart, FILETIME *pEnd, int NumValues, FILETIME *pTimes, DWORD *pKey);
	HRESULT GetPreviousTimeStamp (HANDLE hItem, FILETIME Time, FILETIME *pTimeStamp, DWORD Key);
	HRESULT GetNextTimeStamp (HANDLE hItem, FILETIME Time, FILETIME *pTimeStamp, DWORD Key);
	HRESULT ReadAt (HANDLE hItem, FILETIME TimeStamp, VARIANT *pValue, DWORD *pQuality, DWORD Key);
	// Attribute Functions
	HRESULT ReadCurrentAttribute (HANDLE hItem, DWORD AttributeID, FILETIME *pTime, VARIANT *pValue);
	HRESULT ReadAttributeAt (HANDLE hItem, DWORD AttributeID, FILETIME TimeStamp, VARIANT *pValue, DWORD Key);
	// Aggregate Functions
	HRESULT ReadProcessed (HANDLE hItem, DWORD AggregateID, FILETIME *pStart, FILETIME *pEnd, VARIANT *pValue, DWORD *pQuality, DWORD Key);
    int PrepareAggregates (HANDLE hItem, DWORD AggregateID, FILETIME StartTime, FILETIME EndTime, FILETIME ReSampleInterval, DWORD *pKey);
	// Write Functions
	HRESULT QueryUpdateCapabilities(OPCHDA_UPDATECAPABILITIES *pCapabilities);
	HRESULT	Insert(char *pUserName, HANDLE hItem, FILETIME TimeStamp, VARIANT *pValue, DWORD Quality); 


};

/////////////////////////////////////////////////////////////////////////////
// CHDATest1App:
// See HDATest1.cpp for the implementation of this class
//
class CHDATest1App : public CWinApp
{
public:
	CHDATest1App();

	CHDATest1View	*pView;
	CEventVW		*pEventView;


	HANDLE	hItem[10];
	CString	GetNameFromHandle (HANDLE hItem);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHDATest1App)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CHDATest1App)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HDATEST1_H__127D0739_E0E3_11D4_810A_00C04F790F3B__INCLUDED_)
