// HDATest1View.cpp : implementation of the CHDATest1View class
//

#include "stdafx.h"
#include <afxcview.h>
#include "opchda.h"
#include "opchda_error.h"
#include "wthdasvrapi.h"
#include "HDATest1.h"

#include "HDATest1Doc.h"
#include "HDATest1View.h"
#include "eventvw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// {332FE9EC-E597-11d4-810A-00C04F790F3B}
static const GUID CLSID_Svr = 
{ 0x332fe9ec, 0xe597, 0x11d4, { 0x81, 0xa, 0x0, 0xc0, 0x4f, 0x79, 0xf, 0x3b } };

//
// callback for event messages
// pass control to the bottom splitter view for display.
//
void CALLBACK EXPORT EventCallback(char *pMsg)
{
	CHDATest1App	*pApp;

	pApp = (CHDATest1App *)AfxGetApp();
	if (pApp->pEventView != NULL)
		pApp->pEventView->EventHandler(pMsg);

}

/////////////////////////////////////////////////////////////////////////////
// CHDATest1View

IMPLEMENT_DYNCREATE(CHDATest1View, CView)

BEGIN_MESSAGE_MAP(CHDATest1View, CView)
	//{{AFX_MSG_MAP(CHDATest1View)
	ON_WM_CREATE()
	ON_COMMAND(ID_EDIT_REGISTER, OnEditRegister)
	ON_COMMAND(ID_EDIT_UNREGISTER, OnEditUnregister)
	ON_WM_DESTROY()
	ON_COMMAND(ID_EDIT_NUMBRCLIENTCONNECTIONS, OnEditNumbrclientconnections)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHDATest1View construction/destruction

CHDATest1View::CHDATest1View()
{
	CHDATest1App *pApp;

	pApp = (CHDATest1App *)AfxGetApp();
	pApp->pView = this;
}

CHDATest1View::~CHDATest1View()
{
//	delete the callback object
	if (pCallback != NULL)
		delete (pCallback);
}

BOOL CHDATest1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CHDATest1View drawing

void CHDATest1View::OnDraw(CDC* pDC)
{

	CHDATest1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CHDATest1View printing

BOOL CHDATest1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CHDATest1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CHDATest1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CHDATest1View diagnostics

#ifdef _DEBUG
void CHDATest1View::AssertValid() const
{
	CView::AssertValid();
}

void CHDATest1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CHDATest1Doc* CHDATest1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHDATest1Doc)));
	return (CHDATest1Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHDATest1View message handlers

int CHDATest1View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	CHDATest1App *pApp;


	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	

	// CLSID_Svr identifies this Server
	// (Unique Identifier -- Created with guidgen.exe)
	InitWtHDAsvr (CLSID_Svr, 1000);

	SetWtHDAsvrQualifier ('.');


	//
	// Define all the attributes that we support
	DefineHDAAttribute (OPCHDA_DATA_TYPE, "Data Type", "HDA Item Data Type", VT_I2, FALSE);
	DefineHDAAttribute (OPCHDA_DESCRIPTION, "Description", "HDA Item Description", VT_BSTR, FALSE);
	DefineHDAAttribute (OPCHDA_ENG_UNITS, "Engineering Units", "HDA Item Engineering Units", VT_BSTR, FALSE);
	DefineHDAAttribute (OPCHDA_ITEMID, "Item ID", "HDA Item Name", VT_BSTR, FALSE);

	//
	// Define the Aggregates
	DefineHDAAggregate (OPCHDA_AVERAGE, "Average", "Average Random Value");
	DefineHDAAggregate (OPCHDA_COUNT, "Count", "Number of Random Values");

	//
	// Establish the callback for event messages
	EnableHDAEventMsgs (EventCallback);

	//
	// Setup the main data read callback
	pCallback = new (CMyDataCallback);
	SetHDAServerCallback (pCallback); 

	pApp = (CHDATest1App *)AfxGetApp();

	// 
	// Define our list of items
	pApp->hItem[0] = DefineHDAItem ("A.A.A");
	pApp->hItem[1] = DefineHDAItem ("A.A.B");
	pApp->hItem[2] = DefineHDAItem ("A.A.C");
	pApp->hItem[3] = DefineHDAItem ("A.B.A");
	pApp->hItem[4] = DefineHDAItem ("A.B.B");
	pApp->hItem[5] = DefineHDAItem ("A.B.C");
	pApp->hItem[6] = DefineHDAItem ("A.C.A");
	pApp->hItem[7] = DefineHDAItem ("A.C.B");
	pApp->hItem[8] = DefineHDAItem ("A.C.C");

	return 0;
}


//
// Would generally register the server based on command
// line options during the InitInstance procedure in the App.
//
// This sample uses a menu option to write the registry entries.
//
void CHDATest1View::OnEditRegister() 
{
	CString	SvrName, SvrDescr, HelpPath;
	int	i;

	// get path to executable by parsing the help path
	// contained in CWinApp
	HelpPath = AfxGetApp()->m_pszHelpFilePath;
	i = HelpPath.ReverseFind('\\');
	HelpPath = HelpPath.Left(i+1);
	HelpPath += "HDATest1.exe"; 
	
	SvrName = "HDATestSvr";
	SvrDescr = "OPC HDA Server to Test WT Toolkit";
	// A unique CLSID must be created for each server
	// use GUIDgen.exe to create the ID.
	HDAUpdateRegistry (CLSID_Svr, SvrName, SvrDescr, HelpPath);
	
}

void CHDATest1View::OnEditUnregister() 
{
	CString	SvrName;

	SvrName = "HDATestSvr";
	UnregisterHDAServer (CLSID_Svr, SvrName);
	
}

////////////////////////////////////////////////////////////////////////////////////////
//
//
//			MyDataCallback API
//
///////////////////////////////////////////////////////////////////////////////////////
//
// This is where most of the work gets done.
//
///////////////////////////////////////////////////////////////////////////////////////

CMyDataCallback::CMyDataCallback()
{
}

CMyDataCallback::~CMyDataCallback()
{
}

/////////////////////////////////////////////////////////
//
//
//	This simulated Database will return random values 
//  in the range 95-105 on a timebase of every even 15 seconds
//
//  The code in this section will not be directly applicable to
//	any real server application but is designed only to demonstrate how
//	to respond to queries from the dll.  No attempt is made to return
//  a constant value for any given time stamp, rather a random value is
//  returned each time.
//
/////////////////////////////////////////////////////////

int CMyDataCallback::GetTimeStamps (HANDLE hItem, FILETIME *pStart, FILETIME *pEnd, int NumValues, FILETIME *pTimes, DWORD *pKey)
{
	FILETIME FirstTime, LastTime;
	SYSTEMTIME	SysTime;
	BOOL	IsBackwards;
	int		Counter;
	ULARGE_INTEGER	ui;

	// check to see if we're going in reverse order
	IsBackwards = FALSE;
	if (pStart == NULL)
		IsBackwards = TRUE;
	else if (pEnd != NULL)
		{
		if (CompareFileTime (pStart, pEnd) > 0)
			IsBackwards = TRUE;
		}

	if (!IsBackwards)
		{
		// Round up requested start time
		// to next quarter minute.
		FileTimeToSystemTime (pStart, &SysTime);
		if (SysTime.wSecond <= 15)
			SysTime.wSecond = 0;
		else if (SysTime.wSecond <= 30)
			SysTime.wSecond = 15;
		else if (SysTime.wSecond <= 45)
			SysTime.wSecond = 30;
		else
			SysTime.wSecond = 45;	
		SysTime.wMilliseconds = 0;
		SystemTimeToFileTime (&SysTime, &FirstTime);
		// to keep from having to increment to the next even minute
		// round system time down to previous
		// quarter second interval and then add 15 secs.
		memcpy (&ui, &FirstTime, sizeof(FILETIME));
		ui.QuadPart += 150000000; // FIFTEEN_SECONDS;
		memcpy (&FirstTime, &ui, sizeof(FILETIME));

		if (pEnd != NULL)
			{
			// Round back requested end time
			// to previous quarter minute.
			FileTimeToSystemTime (pEnd, &SysTime);
			if (SysTime.wSecond >= 45)
				SysTime.wSecond = 45;
			else if (SysTime.wSecond >= 30)
				SysTime.wSecond = 30;
			else if (SysTime.wSecond >= 15)
				SysTime.wSecond = 15;
			else
				SysTime.wSecond = 00;
			SysTime.wMilliseconds = 0;
			SystemTimeToFileTime (&SysTime, &LastTime);

			for (Counter=0; Counter<NumValues; Counter++)
				{
				if (CompareFileTime (&FirstTime, &LastTime) > 0)
					break;
				pTimes[Counter] = FirstTime;
				memcpy (&ui, &FirstTime, sizeof(FILETIME));
				ui.QuadPart += 150000000; // FIFTEEN_SECONDS;
				memcpy (&FirstTime, &ui, sizeof(FILETIME));
				}
			}
		else
			{
			for (Counter=0; Counter<NumValues; Counter++)
				{
				pTimes[Counter] = FirstTime;
				memcpy (&ui, &FirstTime, sizeof(FILETIME));
				ui.QuadPart += 150000000; // FIFTEEN_SECONDS;
				memcpy (&FirstTime, &ui, sizeof(FILETIME));
				}
			}
		}
	else	// IsBackwards
		{
		// Round down requested start time
		// to previous quarter minute.
		FileTimeToSystemTime (pStart, &SysTime);
		if (SysTime.wSecond >= 45)
			SysTime.wSecond = 45;
		else if (SysTime.wSecond >= 30)
			SysTime.wSecond = 30;
		else if (SysTime.wSecond >= 15)
			SysTime.wSecond = 15;
		else
			SysTime.wSecond = 00;
		SysTime.wMilliseconds = 0;
		SystemTimeToFileTime (&SysTime, &FirstTime);

		if (pStart != NULL)
			{
			// Round up requested end time
			// to next quarter minute.
			FileTimeToSystemTime (pEnd, &SysTime);
			if (SysTime.wSecond <= 15)
				SysTime.wSecond = 00;
			else if (SysTime.wSecond <= 30)
				SysTime.wSecond = 15;
			else if (SysTime.wSecond <= 45)
				SysTime.wSecond = 30;
			else
				SysTime.wSecond = 45;	// conversion back to FILETIME should correct mins, etc.
			SysTime.wMilliseconds = 0;
			SystemTimeToFileTime (&SysTime, &LastTime);
		//	memcpy (&ui, &LastTime, sizeof(FILETIME));
		//	ui.QuadPart += 150000000; // FIFTEEN_SECONDS;
		//	memcpy (&LastTime, &ui, sizeof(FILETIME));

			for (Counter=0; Counter<NumValues; Counter++)
				{
				if (CompareFileTime (&FirstTime, &LastTime) < 0)
					break;
				pTimes[Counter] = FirstTime;
				memcpy (&ui, &FirstTime, sizeof(FILETIME));
				ui.QuadPart -= 150000000; // FIFTEEN_SECONDS;
				memcpy (&FirstTime, &ui, sizeof(FILETIME));
				}
			}
		else
			{
			for (Counter=0; Counter<NumValues; Counter++)
				{
				pTimes[Counter] = FirstTime;
				memcpy (&ui, &FirstTime, sizeof(FILETIME));
				ui.QuadPart -= 150000000; // FIFTEEN_SECONDS;
				memcpy (&FirstTime, &ui, sizeof(FILETIME));
				}
			}
		}


	return (Counter);
}

HRESULT CMyDataCallback::GetPreviousTimeStamp (HANDLE hItem, FILETIME Time, FILETIME *pTimeStamp, DWORD Key)
{
	SYSTEMTIME	SysTime;
	ULARGE_INTEGER	ui;

	FileTimeToSystemTime (&Time, &SysTime);

	// round target time back to nearest 15 sec interval
	if (SysTime.wSecond >= 45)
		SysTime.wSecond = 45;
	else if (SysTime.wSecond >= 30)
		SysTime.wSecond = 30;
	else if (SysTime.wSecond >= 15)
		SysTime.wSecond = 15;
	else
		SysTime.wSecond = 00;
	SysTime.wMilliseconds = 0;
	SystemTimeToFileTime (&SysTime, pTimeStamp);
	memcpy (&ui, pTimeStamp, sizeof(FILETIME));
	ui.QuadPart -= 150000000; // FIFTEEN_SECONDS;
	memcpy (pTimeStamp, &ui, sizeof(FILETIME));
	return (S_OK);
}

HRESULT CMyDataCallback::GetNextTimeStamp (HANDLE hItem, FILETIME Time, FILETIME *pTimeStamp, DWORD Key)
{
	SYSTEMTIME	SysTime;
	ULARGE_INTEGER	ui;

	FileTimeToSystemTime (&Time, &SysTime);

	// round target time back up to nearest 15 sec interval
	if (SysTime.wSecond <= 15)
		SysTime.wSecond = 00;
	else if (SysTime.wSecond <= 30)
		SysTime.wSecond = 15;
	else if (SysTime.wSecond <= 45)
		SysTime.wSecond = 30;
	else
		SysTime.wSecond = 45;	// conversion back to FILETIME should correct mins, etc.
	SysTime.wMilliseconds = 0;
	SystemTimeToFileTime (&SysTime, pTimeStamp);
	memcpy (&ui, pTimeStamp, sizeof(FILETIME));
	ui.QuadPart += 150000000; // FIFTEEN_SECONDS;
	memcpy (pTimeStamp, &ui, sizeof(FILETIME));
	return (S_OK);
}

HRESULT CMyDataCallback::ReadAt (HANDLE hItem, FILETIME TimeStamp, VARIANT *pValue, DWORD *pQuality, DWORD Key)
{
	VARIANT var;
	SYSTEMTIME	SysTime;
	int	r;
	float	fr;

	// just return a random value here with good quality
	// 
	// in the real world we would need to compare the requested timestamp
	// with available data and extrapolate a value if we do not have
	// the exact data
	VariantInit (&var);
	var.vt = VT_R4;

	r = rand();	
	fr = (float)r / 32767.0f;	// random number between 0.0-1.0

	var.fltVal = 95.0f + (fr * 10.0f);	// generate random number betwen 95-105
	VariantCopy (pValue, &var);

	FileTimeToSystemTime (&TimeStamp, &SysTime);
	if ((SysTime.wSecond == 0) || (SysTime.wSecond == 15) ||
		(SysTime.wSecond == 30) || (SysTime.wSecond == 45))
		*pQuality = OPCHDA_RAW;
	else
		*pQuality = OPCHDA_INTERPOLATED;

	VariantClear (&var);

	return (S_OK);
}

WCHAR *WSTRFromCString(const CHAR *buf)
{
	int	length, i;
	WCHAR	*temp;

	length = strlen(buf) + 1;
	temp = new WCHAR[strlen(buf) + 1];
	
	if(temp)
		{
		for(i=0; i<length; i++) temp[i] = (WCHAR) buf[i];
		}

	return temp;
}

void WSTRFree(WCHAR * c)
{
	if (c == NULL)
		return;

	delete c;
}


HRESULT CMyDataCallback::ReadCurrentAttribute (HANDLE hItem, DWORD AttributeID, FILETIME *pTime, VARIANT *pValue)
{
	VARIANT var;
	WCHAR	*pWCHAR;
	CHDATest1App *pApp;

	pApp = (CHDATest1App *)AfxGetApp();

	VariantInit (&var);
	switch (AttributeID)
		{
		case OPCHDA_DATA_TYPE:
			var.vt = VT_I2;
			var.intVal = VT_R4;
			VariantCopy (pValue, &var);
			VariantClear (&var);
			return (S_OK);
		case OPCHDA_DESCRIPTION:
			pWCHAR = WSTRFromCString ("Random Floating Point Values");
			var.vt = VT_BSTR;
			var.bstrVal = SysAllocString (pWCHAR);
			WSTRFree (pWCHAR);
			VariantCopy (pValue, &var);
			VariantClear (&var);
			return (S_OK);
		case OPCHDA_ENG_UNITS:
			pWCHAR = WSTRFromCString ("Counts");
			var.vt = VT_BSTR;
			var.bstrVal = SysAllocString (pWCHAR);
			WSTRFree (pWCHAR);
			VariantCopy (pValue, &var);
			VariantClear (&var);
			return (S_OK);
		case OPCHDA_ITEMID:
			pWCHAR = WSTRFromCString (pApp->GetNameFromHandle(hItem));
			var.vt = VT_BSTR;
			var.bstrVal = SysAllocString (pWCHAR);
			WSTRFree (pWCHAR);
			VariantCopy (pValue, &var);
			VariantClear (&var);
			return (S_OK);
		default:
			VariantClear (&var);
			return (OPC_E_INVALIDATTRID);
		}

}

HRESULT CMyDataCallback::ReadAttributeAt (HANDLE hItem, DWORD AttributeID, FILETIME TimeStamp, VARIANT *pValue, DWORD Key)
{
	HRESULT	hr;
	FILETIME	Now;

	hr = ReadCurrentAttribute (hItem, AttributeID, &Now, pValue);
	if (hr == S_OK)
		hr = OPC_S_CURRENTVALUE;

	return (hr);
}

int CMyDataCallback::PrepareAggregates (HANDLE hItem, DWORD AggregateID, FILETIME StartTime, FILETIME EndTime, FILETIME ReSampleInterval, DWORD *pKey)
{
	return (0);
}
	
HRESULT CMyDataCallback::ReadProcessed (HANDLE hItem, DWORD AggregateID, FILETIME *pStart, FILETIME *pEnd, VARIANT *pValue, DWORD *pQuality, DWORD Key)
{
	VARIANT var;
	CHDATest1App *pApp;
	int	r;
	float	fr;
	FILETIME pTimes[100];
	DWORD	key;

	pApp = (CHDATest1App *)AfxGetApp();

	VariantInit (&var);
	switch (AggregateID)
		{
		case OPCHDA_AVERAGE:
				// just return a random value here with good quality
				var.vt = VT_R4;

				r = rand();	
				fr = (float)r / 32767.0f;	// random number between 0.0-1.0

				var.fltVal = 95.0f + (fr * 10.0f);	// generate random number betwen 95-105
				VariantCopy (pValue, &var);
				*pQuality = OPCHDA_CALCULATED;
				VariantClear (&var);
				return (S_OK);
				break;
		case OPCHDA_COUNT:
				// figure out how many 15 sec intervals is in the defined time period
				r = GetTimeStamps (hItem, pStart, pEnd, 100, pTimes, &key);
				var.vt = VT_R4;
				var.fltVal = (float)r;
				VariantCopy (pValue, &var);
				*pQuality = OPCHDA_CALCULATED;
				VariantClear (&var);
				return (S_OK);
		default:
			VariantClear (&var);
			return (OPC_E_NOT_AVAIL);
		}



}

HRESULT CMyDataCallback::QueryUpdateCapabilities(OPCHDA_UPDATECAPABILITIES *pCapabilities)
{

	*pCapabilities = OPCHDA_INSERTCAP;
	return (S_OK);
}

HRESULT CMyDataCallback::Insert(char *pUserName, HANDLE hItem, FILETIME TimeStamp, VARIANT *pValue, DWORD Quality)
{

	return (S_OK);
}


void CHDATest1View::OnDestroy() 
{
	RequestHDADisconnect();
	Sleep(2000);

	CView::OnDestroy();
	
}

void CHDATest1View::OnEditNumbrclientconnections() 
{
	int	number;
	char	buf[100];

	number = NumbrHDAClientConnections ();
	sprintf (buf, "Number Of Client Connections: %d", number);
	AfxMessageBox (buf, MB_OK);
}
