Attribute VB_Name = "Module1"
Public Type FileTime
    dwLowDateTime As Long
    dwHighDateTime As Long
   End Type
   
Public Type OPCHDA_TIME
    IsString    As Boolean
    SzTime      As Long      'pointer to WORD String
    TimeStamp   As FileTime
    End Type

Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef dest As Any, ByRef source As Any, ByVal numbytes As Long)

   
'
'  Initialization and Registration functions
'
'
'  InitWtHDAsvr()
'      Initializes DCOM, Security, and creates the Server ClassFactory
Declare Function InitWtHDAsvr Lib "WtHDASvr" Alias "_InitWtHDAsvr1@8" (ByRef CLSID_Svr As Byte, ByVal ServerRate As Long) As Long
'
'  HDAUpdateRegistry()
'      Makes the appropriate entries to the Windows Registry to identify the Server.
'      the argument types.
Declare Function HDAUpdateRegistry Lib "WtHDASvr" Alias "_HDAUpdateRegistry1@16" (ByRef CLSID_Svr As Byte, ByRef Name As Byte, ByRef Descr As Byte, ByRef ExePath As Byte) As Long
'
'  UnregisterHDAServer()
'      Removes the Registry Entries
Declare Function UnregisterHDAServer Lib "WtHDASvr" Alias "_UnregisterHDAServer1@8" (ByRef CLSID_Svr As Byte, ByRef Name As Byte) As Long


'
'  Data Definition functions
''  The OPC HDA Specification defines certain ID's to be used for certain Attributes and Aggregates.
'  Support for these values is optional for any given HDA Server, however, if a server chooses to
'  define it's own set of Attributes/Aggregates, it should use ID's outside the range of the
'  pre-defined values.  Consult the OPC HDA Specification for the list of values which have
'  been pre-defined.

'
'  DefineHDAItem()
'      The application defines the names of the items it supports in it's historized database.
'      The DLL uses the item names to satisfy browsing requests by HDA clients.  The application
'      must maintain the returned HANDLE value to identify the item.
Declare Function DefineHDAItem Lib "WtHDASvr" Alias "_DefineHDAItem@4" (ByRef Name As Byte) As Long
Declare Function DeleteHDAItem Lib "WtHDASvr" Alias "_DeleteHDAItem@4" (ByRef Name As Byte) As Long
'
'  DefineHDAAttribute()
'      The application defines which attributes it supports for historized items.  If a
'      given attribute is saved with the item, the IsArchived parameter should be set to TRUE.
'      Otherwise, the DLL will only issue the ReadCurrentAttribute function in CWtHDACallback
'      to satisfy Attribute read requests from the client.
Declare Function DefineHDAAttribute Lib "WtHDASvr" Alias "_DefineHDAAttribute@20" (ByVal Id As Long, ByRef Name As Byte, ByRef Descr As Byte, ByVal VarType As Long, ByVal IsArchived As Long) As Long
'
'  DefineHDAAggregate()
'      The application defines a description for each calclulation. (Aggregate), it supports.
Declare Function DefineHDAAggregate Lib "WtHDASvr" Alias "_DefineHDAAggregate@12" (ByVal Id As Long, ByRef Name As Byte, ByRef Descr As Byte) As Long
'



'
'  Miscellaneous functions
'
'
'  SetHDAVendorInfo()
'      Allows the application to specify a vendor specifc string to identify
'      the server.  This string will appear as part of the OPCSERVERSTATUS structure
'      returned by the GetStatus Interface.
Declare Function SetHDAVendorInfo Lib "WtHDASvr" Alias "_SetHDAVendorInfo@4" (ByRef VendorInfo As Byte) As Long
'
'   NumbrHDAClientConnections()
'      Allows the application to determine how many clients are currently
'      connected.  May be used in the Disconnect callback procedure to shutdown
'      the server application when the last client disaonnects.
Declare Function NumbrHDAClientConnections Lib "WtHDASvr" Alias "_NumbrHDAClientConnections@0" () As Long
'
'  RequestHDADisconnect()
'      Allows the application to request that all clients disconnect
Declare Sub RequestHDADisconnect Lib "WtHDASvr" Alias "_RequestHDADisconnect@0" ()
'
'  HDAConvertVBDateToFileTime()
'       Converts VB Date Type to OPC FILETIME Structure
Declare Function HDAConvertVBDateToFileTime Lib "WtHDASvr" Alias "_HDAConvertVBDateToFileTime@8" (ByRef VBDate As Date, ByRef FTime As FileTime) As Long
'
'  HDAConvertFileTimeToVBDate()
'       Converts OPC FILETIME Structure to VB Date Type
Declare Function HDAConvertFileTimeToVBDate Lib "WtHDASvr" Alias "_HDAConvertFileTimeToVBDate@8" (ByRef FTime As FileTime, ByRef VBDate As Date) As Long
'
'  SetHDAQualifier()
'       Sets delimiting character used for segmenting tag names
Declare Function SetHDAQualifier Lib "WtHDASvr" Alias "_SetWtHDAsvrQualifier@4" (ByVal Delimiter As Byte) As Long
'
'  DeactivateHDAsvr30MinTimer()
'
Declare Function DeactivateHDAsvr30MinTimer Lib "WtHDASvr" Alias "_DeactivateHDAsvr30MinTimer@4" (ByRef AccessString As Byte) As Long




'
'  Callback definition functions
'
'
'  EnableHDADisconnectNotification()
'      Allows the dll to call back into the application whenever a client disconnects.
Declare Function EnableHDADisconnectNotification Lib "WtHDASvr" Alias "_EnableHDADisconnectNotification@4" (ByVal Callback As Long) As Long
'
'  EnableHDAEventMsgs()
'      Provides a seperate callback procedure to allow the DLL to post messages back
'      to the application primarily for debugging purposes.
Declare Function EnableHDAEventMsgs Lib "WtHDASvr" Alias "_EnableHDAEventMsgs@4" (ByVal Callback As Long) As Long
'
'   EnableGetTimeStampCallback ()
Declare Function EnableGetTimeStampCallback Lib "WtHDASvr" Alias "_EnableGetTimeStampCallback@4" (ByVal Callback As Long) As Long
'
'   EnableGetPreviousTimeStampCallback ()
'   EnableGetNextTimeStampCallback ()
Declare Function EnableGetPreviousTimeStampCallback Lib "WtHDASvr" Alias "_EnableGetPreviousTimeStampCallback@4" (ByVal Callback As Long) As Long
Declare Function EnableGetNextTimeStampCallback Lib "WtHDASvr" Alias "_EnableGetNextTimeStampCallback@4" (ByVal Callback As Long) As Long
'
'   EnableReadAtCallback ()
Declare Function EnableReadAtCallback Lib "WtHDASvr" Alias "_EnableReadAtCallback@4" (ByVal Callback As Long) As Long
'
'   EnableReadCurrentAttributeCallback ()
'   EnableReadAttributeAtCallback ()
Declare Function EnableReadCurrentAttributeCallback Lib "WtHDASvr" Alias "_EnableReadCurrentAttributeCallback@4" (ByVal Callback As Long) As Long
Declare Function EnableReadAttributeAtCallback Lib "WtHDASvr" Alias "_EnableReadAttributeAtCallback@4" (ByVal Callback As Long) As Long
'
'   EnablePrepareAggregatesCallback ()
Declare Function EnablePrepareAggregatesCallback Lib "WtHDASvr" Alias "_EnablePrepareAggregatesCallback@4" (ByVal Callback As Long) As Long
'
'   EnableReadProcessedCallback ()
Declare Function EnableReadProcessedCallback Lib "WtHDASvr" Alias "_EnableReadProcessedCallback@4" (ByVal Callback As Long) As Long
'
'   EnableQueryUpdateCapabilitiesCallback ()
Declare Function EnableQueryUpdateCapabilitiesCallback Lib "WtHDASvr" Alias "_EnableQueryUpdateCapabilitiesCallback@4" (ByVal Callback As Long) As Long
'
'   EnableInsertCallback ()
Declare Function EnableInsertCallback Lib "WtHDASvr" Alias "_EnableInsertCallback@4" (ByVal Callback As Long) As Long
'
'   EnableReplaceCallback ()
Declare Function EnableReplaceCallback Lib "WtHDASvr" Alias "_EnableReplaceCallback@4" (ByVal Callback As Long) As Long
'
'   EnableInsertReplaceCallback ()
Declare Function EnableInsertReplaceCallback Lib "WtHDASvr" Alias "_EnableInsertReplaceCallback@4" (ByVal Callback As Long) As Long
'
'   EnableDeleteRawCallback ()
Declare Function EnableDeleteRawCallback Lib "WtHDASvr" Alias "_EnableDeleteRawCallback@4" (ByVal Callback As Long) As Long
'
'   EnableDeleteAtCallback ()
Declare Function EnableDeleteAtCallback Lib "WtHDASvr" Alias "_EnableDeleteAtCallback@4" (ByVal Callback As Long) As Long



'  DISCONNECTPROC
'      Notifies the Server Application whenever a client disconnects.  The DWORD argument
'      defines the number of client connections remaining.  This callback may be used
'      to shutdown the server when the last client disconnects.
Sub DisconnectCallback(ByVal nConnects As Long)

End Sub
'  EVENTMSGPROC
'      Allows the Application to receive event messages from the WtOPCsvr.dll for
'      tracing OPC Client Interface calls.  Primarily used for debugging purposes.
'
Sub EventMsgCallback(ByRef Msg As Byte)

End Sub

'  TIMESTAMPPROC
'      Allows the DLL to retrieve a list of all the TimeStamps available
'      in the application database between the specified Start & End times.  As per the HDA
'      spec, the Start time may be greater than the End time, in which case TimeStamps must
'      be returned in reverse order.  If more data items exist in the specified time range
'      than can be filled in the allocated array, (limited by NumValues), the application
'      should return OPC_S_MOREDATA.  If the End time is not specified, (pEnd == NULL),
'      the application must use the Start time and NumValues to fill the TimeStamp array.
'
Sub TimeStampCallback(ByVal hItem As Long, ByRef StartTime As FileTime, ByRef EndTime As FileTime, ByVal MaxValues As Long, ByRef TimeStamp As FileTime, ByRef NumberOfValues As Long)

End Sub

'   PREVTIMESTAMPPROC and NEXTTIMESTAMPPROC
'       allows the DLL to retrieve the HDA Bounding
'      value for a time period as requested by a client.  The application should return the
'      Timestamp of the historized item immediately prior to or immediately following the
'      specified FILETIME.
'
Sub PrevTimeStampCallback(ByVal hItem As Long, ByVal Time As Double, ByRef TimeStamp As FileTime, ByRef hResult As Long)

End Sub
Sub NextTimeStampCallback(ByVal hItem As Long, ByVal Time As Double, ByRef TimeStamp As FileTime, ByRef hResult As Long)

End Sub


'   READATPROC
'      used by the DLL to obtain the value and quality of an item at a specified time.
'      Generally, the requested timestamp will have been obtained by a previous call to
'      GetTimeStamps, however, the HDA spec allows a client to request the value of an item at
'      any given time.  In this case, the application should extrapolate the value for the
'      item based on the surrounding data points and return OPCHDA_INTERPOLATED.  If the requested
'      timestamp is out of bounds of the database, the application should return OPC_S_NODATA.
'
Sub ReadAtCallback(ByVal hItem As Long, ByVal Time As Double, ByRef Value As Variant, ByRef Quality As Long, ByRef hResult As Long)

End Sub

'   CURRENTATTRIBUTEPROC & READATTRIBUTEPROC
'      When the application starts up, it specifies the attributes supported for
'      the historized data items.  It also specifies, for each attribute, whether or
'      not the attribute is histroized along with the item.  These two callback functions
'      allow the dll to read the current value of an attribute for a given item and, if
'      supported, the value for an attribute at a specifiied point in time.
Sub CurrentAttributeCallback(ByVal hItem As Long, ByVal Id As Long, ByRef Time As FileTime, ByRef Value As Variant, ByRef hResult As Long)

End Sub
Sub ReadAttributeCallback(ByVal hItem As Long, ByVal Id As Long, ByVal TimeStamp As Double, ByRef Value As Variant, ByRef hResult As Long)

End Sub

'   PREPAREAGGREGATESPROC
'      allows the application to access the data and prepare
'      a list of calculated values as requested by an hda client.  The return value indicates
'      the number of calculated values, (Intervals), contained within the specified time range
Sub PrepareAggregatesCallback(ByVal hItem As Long, ByVal Id As Long, ByVal StartTime As Double, ByVal EndTime As Double, ByVal ReSampleInterval As Double, ByRef NumberOfValues As Long)

End Sub

'   READPROCESSEDPROC
'      allows the DLL to read a value from the application database
'      that is calculated over a specified time range.  The calculation to be performed on the
'      data set is defined by AggregateID.  The server application defines the list of
'      supported Aggregates during start-up.
Sub ReadProcessedCallback(ByVal hItem As Long, ByVal Id As Long, ByRef StartTime As FileTime, ByRef EndTime As FileTime, ByRef Value As Variant, ByRef Quality As Long, ByRef hResult As Long)

End Sub


'   QUERYUPDATECAPABILITIESPROC
'     This function is called by the client to determine if the server supports
'      write operations.  The server should respond with any combination of the
'      following:
'              OPCHDA_INSERTCAP    = 0x1,
'              OPCHDA_REPLACECAP   = 0x2,
'              OPCHDA_INSERTREPLACECAP = 0x4,
'              OPCHDA_DELETERAWCAP = 0x8,
'              OPCHDA_DELETEATTIMECAP  = 0x10
Sub QueryUpdateCapabilitiesCallback(ByRef SupportedCaps As Long, ByRef hResult As Long)

End Sub

'   INSERTPROC
'     This function allows the client to insert a record into the HDA Server database.
'     If the operation is successful, return S_OK in hResult.
Sub InsertCallback(ByRef UserName As Byte, ByVal hItem As Long, ByVal dwLowDateTime As Long, ByVal dwHighDateTime As Long, ByRef pValue As Variant, ByVal Quality As Long, ByRef hResult As Long)

End Sub


'   REPLACEPROC
'     This function allows the client to replace a record into the HDA Server database.
'     If the operation is successful, retuen S_OK in hResult.
Sub ReplaceCallback(ByRef UserName As Byte, ByVal hItem As Long, ByVal dwLowDateTime As Long, ByVal dwHighDateTime As Long, ByRef pValue As Variant, ByVal Quality As Long, ByRef hResult As Long)

End Sub

'   INSERTREPLACEPROC
'     This function allows the client to insert or replace a record into the HDA Server database.
'     If the operation is successful, retuen S_OK in hResult.
Sub InsertReplaceCallback(ByRef UserName As Byte, ByVal hItem As Long, ByVal dwLowDateTime As Long, ByVal dwHighDateTime As Long, ByRef pValue As Variant, ByVal Quality As Long, ByRef hResult As Long)

End Sub

'   DELETERAWPROC
'     This function allows the client to delete a series of records from the HDA Server database.
'     If the operation is successful, retuen S_OK in hResult.
Sub DeleteRawCallback(ByRef UserName As Byte, ByVal hItem As Long, ByRef Time1 As OPCHDA_TIME, ByRef Time2 As OPCHDA_TIME, ByRef hResult As Long)

End Sub

'   DELETEATPROC
'     This function allows the client to delete a record from the HDA Server database.
'     If the operation is successful, retuen S_OK in hResult.
Sub DeleteAtCallback(ByRef UserName As Byte, ByVal hItem As Long, ByVal dwLowDateTime As Long, ByVal dwHighDateTime As Long, ByRef pValue As Variant, ByVal Quality As Long, ByRef hResult As Long)

End Sub

